;##########################################################################
.386
.model flat, stdcall
option casemap:none
title Console
;##########################################################################
include C:\masm32\include\windows.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\user32.inc
include C:\masm32\macros\macros.inc
includelib C:\masm32\lib\kernel32.lib
includelib C:\masm32\lib\user32.lib
;##########################################################################
m2m MACRO M1, M2
	push	M2
	pop	M1
ENDM
;##########################################################################
;##########################################################################
	CurDate		TEXTEQU	<">, @Date, <">
	CurTime		TEXTEQU	<">, @Time, <">
	CurFileName	TEXTEQU	<">, @FileCur, <">
;##########################################################################
ustr2dw		PROTO
ProcessCmdLine	PROTO
;##########################################################################
.const
;##########################################################################
.data
;##########################################################################
.data?
	hLibrary	dd		?
	dwStack		dd		? 
	argc		dd		?
	argv		dd		16 dup (?)
;##########################################################################
.code
start:	pushx	ebx esi edi
	mov	[dwStack], esp  
	call	ProcessCmdLine
	cmp	[argc], 4
	jb	@@quit
	invoke	LoadLibrary, [argv+04h]
	test	eax, eax
	mov	[hLibrary], eax
	jz	@@quit
	sub	[argc], 3
	jle	@@quit
	mov	ebx, OFFSET argv+0Ch
@@arg:	mov	esi, [ebx]
	cmp	word ptr [esi], ":s"	; string
	je	@@str
	call	ustr2dw
	push	eax
	jmp	@@next 
@@str:  add	esi, 2
	push	esi
@@next:	add	ebx, 04h
	dec	[argc]
	jg	@@arg    
	invoke	GetProcAddress, [hLibrary], [argv+08h]
	test	eax, eax
	jz	@@quit
	call	eax 
@@quit:	mov	esp, [dwStack]
	invoke	FreeLibrary, [hLibrary]
	popx	ebx esi edi 
	invoke	ExitProcess, 0
;##########################################################################
ustr2dw proc
	xor	eax, eax
	xor	edx, edx
	jmp	@@chkz
@@redo:	sub	dl, "0"
	mov	ecx, eax
	add	eax, eax
	shl	ecx, 3
	inc	esi
	add	eax, ecx
	add	eax, edx
@@chkz:	mov	dl, [esi]
	test	dl, dl
	jnz	@@redo
	ret
ustr2dw endp
;##########################################################################
ProcessCmdLine proc
	push	edi
	push	esi
	push	ebx
	call	GetCommandLine
	mov	esi, eax
	mov	edi, OFFSET argv
	xor	ecx, ecx
	xor	ebx, ebx
	xor	edx, edx
@@cmss:	mov	eax, esi
	mov	dl, 20h
	cmp	byte ptr [esi], 22h
	sete	cl
	lea	edx, [edx+ecx*2]
	add	eax, ecx
	stosd
@@cm00:	inc	esi
	cmp	byte ptr [esi], 0
	je	@@cm01
	cmp	byte ptr [esi], dl
	jne	@@cm00
	mov	byte ptr [esi], 0
	add	esi, ecx
	inc	esi
	cmp	byte ptr [esi], 0
	je	@@cm01
	inc	[argc]
	jmp	@@cmss
@@cm01:	pop	ebx
	pop	esi
	pop	edi
	inc	[argc]
	ret
ProcessCmdLine endp
;##########################################################################
;##########################################################################
;##########################################################################
end start